//TODO:	Organize into smaller functions
//		Dumb idea: Mario 64 Triple Jump
//		Another dumb idea: quake b-hopping

CV_RegisterVar({
	name = "springracer_available",
	defaultvalue = "On",
	flags = CV_NETVAR,
	possiblevalue = CV_OnOff,
	description = "Allow players to enable spring jumping."
})

CV_RegisterVar({
	name = "springracer_active",
	defaultvalue = "False",
	flags = CV_CALL,
	possiblevalue = CV_TrueFalse,
	description = "Toggles jumping.",
	func = 	function(var)
				COM_BufInsertText(consoleplayer, "springracer_toggle ".. var.value)
			end
})

COM_AddCommand("springracer_toggle", function(player, var)
	if not CV_FindVar("springracer_available").value then
		CONS_Printf(player, "Jumping has been disabled by the server host.")
		return
	end
	player.springracerenable = tonumber(var)
	CONS_Printf(player, "Jumping toggled. Wait for map load to see results!")
	S_StartSound(nil, sfx_3db06, player)
end, COM_NOSHOWHELP)

local EngineSwap_classes = { --class check courtesy of eldog <3
    ['a'] = { minspeed = 1, minweight = 1},
    ['b'] = { minspeed = 4, minweight = 1},
    ['c'] = { minspeed = 7, minweight = 1},
    ['d'] = { minspeed = 1, minweight = 4},
    ['e'] = { minspeed = 4, minweight = 4},
    ['f'] = { minspeed = 7, minweight = 4},
    ['g'] = { minspeed = 1, minweight = 7},
    ['h'] = { minspeed = 4, minweight = 7},
    ['i'] = { minspeed = 7, minweight = 7},
}

local jumpsounds = {
	['a'] = sfx_jumpa,
	['b'] = sfx_jumpb,
	['c'] = sfx_jumpc,
	['d'] = sfx_jumpd,
	['e'] = sfx_jumpe,
	['f'] = sfx_jumpf,
	['g'] = sfx_jumpg,
	['h'] = sfx_jumph,
	['i'] = sfx_jumpi
}

local function EngineSwap_GetStats(player)
    local stats = {}
    
    stats.speed  = player.kartspeed
    stats.weight = player.kartweight
    
    for k,v in pairs(EngineSwap_classes) do
        if (stats.speed  >= v.minspeed  and stats.speed  < v.minspeed  + 3) and
           (stats.weight >= v.minweight and stats.weight < v.minweight + 3) then
            stats.class = k
            -- Substats are values 0-2 that represent your position within an engine class
            -- 0,0 is top left, 2,2 is bottom right
            stats.subspeed  = stats.speed  - v.minspeed
            stats.subweight = stats.weight - v.minweight
        end
    end
    
    return stats.class
end

addHook("ThinkFrame", function()
	if not CV_FindVar("springracer_available").value then return end
	if leveltime == 1 then
		for player in players.iterate do player.enablespring = player.springracerenable end
	end
end)

addHook("PlayerThink", function(player) --the jump mechanics
	if not player.enablespring or not CV_FindVar("springracer_available").value then return end
	
	if player.srcanjump == nil --i feel better when these aren't "nil" by default
		player.srcanjump = true
	end
	if player.srjumping == nil
		player.srjumping = false
	end
	
	local drifting = player.cmd.buttons & BT_DRIFT
	local grounded = P_IsObjectOnGround(player.mo)
	local jumpsfx = jumpsounds[EngineSwap_GetStats(player)]
	
	//the logic (this took me way too long to figure out...)
	if (drifting and grounded)
	or (not drifting and not grounded)
	or (not drifting and grounded) then
		player.srjumping = false
	end
	
	if (not drifting and grounded)
	and not player.srjumping 
		player.srcanjump = true
	elseif (drifting and not grounded) then
		player.srcanjump = false
	end
	
	//the jump
	if drifting and grounded and player.srcanjump then
		if player.mo.eflags & MFE_VERTICALFLIP
			player.mo.momz = -14*mapobjectscale
		else
			player.mo.momz = 14*mapobjectscale
		end
		S_StartSound(player.mo, jumpsfx)
		player.srjumping = true
		player.srcanjump = false
	end
	
	//the "slowfall"
	if player.srjumping then
		if player.mo.eflags & MFE_VERTICALFLIP
			player.mo.momz = $ + 1*mapobjectscale
		else
			player.mo.momz = $ - 1*mapobjectscale
		end
	end
end)

--debug stuff
//local function springracerdebug(v, player)
	//v.drawString(0, 0, "Can Jump: " + player.srcanjump, V_SNAPTOLEFT)
	//v.drawString(0, 8, "Is Jumping: " + player.srjumping, V_REDMAP|V_SNAPTOLEFT)
//end
//hud.add(springracerdebug)
